<template id="categories-stats">
  <div class="box box-warning">
    <div class="box-header with-border">
      <h3 class="box-title">Categories savings stats</h3>
      <div class="box-tools pull-right">
        <button @click="showTable()" type="button" class="btn show-table-btn">
          <i class="fa fa-table"></i>
        </button>
      </div>
    </div>
    <div class="box-body">
      <div class="chart">
        <div class="card">
          <div class="card-body">
            <div class="chart">
              <BarChart :chartData="chartData" :options="optionsBar"></BarChart>
            </div>
            <div v-if="show_table && tableStats" class="table-area">
              <table class="table table-hover table-striped">
                <tbody>
                  <tr>
                    <th>Category name</th>
                    <th>Amount, €</th>
                  </tr>

                  <tr v-for="result in tableStats.data" :key="result.name">
                    <td>{{ result.name}}</td>
                    <td>{{ result.amount }} €</td>
                  </tr>
                </tbody>
              </table>
            </div>
            <div v-if="show_table" class="card-footer">
              <pagination
                class="paginator"
                :data="tableStats"
                @pagination-change-page="getTableStats"
              ></pagination>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.13.0/moment.min.js"></script>
<script src="https://chartjs-plugin-datalabels.netlify.com/guide/positioning.html#clamping"></script>

<script>
import DoughnutChart from "./DoughnutChart.vue";
import BarChart from "./BarChart.vue";
import moment from "moment";

export default {
  props: ["date_interval", "stats", "interval"],

  components: {
    DoughnutChart,
    BarChart
  },
  data: function() {
    return {
      chartData: {},
      optionsPie: null,
      optionsBar: null,
      tableStats: {},
      show_table: false
    };
  },

  created: function() {
    this.setChartValues();
  },

  watch: {
    date_interval: function() {
      this.setChartValues();
      this.show_table = false;
    },

    stats: function() {
      this.setChartValues();
    }
  },

  methods: {
    showTable() {
      if (this.show_table) {
        this.show_table = false;
      } else {
        this.getTableStats();
        this.show_table = true;
      }
    },

    getTableStats(page = 1) {
      let uri = "api/saving-campaigns-categories-stats/" + this.interval;

      axios
        .get(uri, {
          params: {
            page: page,
            paginate: 1
          }
        })
        .then(response => {
          this.tableStats = response.data.results;
        });
    },

    setChartValues: function() {
      let labels = this.stats.map(list => {
        return list.name;
      });

      let amounts = this.stats.map(list => {
        return list.amount;
      });

      this.assignChartValues(labels, amounts);
    },

    assignChartValues: function(labels, amounts) {
      this.chartData = {
        labels: labels,
        datasets: [
          {
            label: "Transaction sum",
            backgroundColor: Fire.getRandomColorHex(labels.length),
            borderColor: Fire.getRandomColorHex(),
            fill: true,
            data: amounts,
            datalabels: {
              labels: {
                title: {
                  font: {
                    weight: "bold",
                    size: 15
                  }
                }
              }
            }
          }
        ]
      };

      this.optionsBar = {
        title: {
          display: false
        },
        scales: {
          yAxes: [
            {
              scaleLabel: {
                display: true,
                labelString: "Saved amount, €"
              },
              ticks: {
                beginAtZero: true
              }
            }
          ],
          xAxes: [
            {
              scaleLabel: {
                display: true,
                labelString: "categories"
              }
            }
          ]
        },
        tooltips: {
          callbacks: {
            label: function(tooltipItem, data) {
              return data["datasets"][0]["data"][tooltipItem["index"]] + " €";
            },

            title: function(tooltipItem, data) {
              return data["labels"][tooltipItem[0]["index"]];
            }
          },
          xPadding: 8,
          backgroundColor: "#FFF",
          titleFontSize: 18,
          titleFontColor: "#0066ff",
          bodyFontColor: "#000",
          bodyFontSize: 18,
          displayColors: false
        },

        plugins: {
          datalabels: {
            color: "black",
            display: false,
            formatter: function(value, context) {
              return amounts[context.dataIndex] + " €";
            }
          }
        },

        callbacks: {
          labelColor: function(tooltipItem, chart) {
            return {
              borderColor: "red",
              backgroundColor: "red"
            };
          },
          labelTextColor: function(tooltipItem, chart) {
            return "red";
          }
        },
        legend: {
          display: false
        }
      };
    }
  }
};
</script>
